Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/HeuristicLab.Optimization.Networks.Views-3.3.csproj
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/HeuristicLab.Optimization.Networks.Views-3.3.csproj	(revision 11468)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/HeuristicLab.Optimization.Networks.Views-3.3.csproj	(revision 11500)
@@ -91,4 +91,52 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="### obsolete\ClientPortView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\ClientPortView.Designer.cs">
+      <DependentUpon>ClientPortView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="### obsolete\ClientServicePortView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\ClientServicePortView.Designer.cs">
+      <DependentUpon>ClientServicePortView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="### obsolete\InputOutputPortView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\InputOutputPortView.Designer.cs">
+      <DependentUpon>InputOutputPortView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="### obsolete\InputPortView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\InputPortView.Designer.cs">
+      <DependentUpon>InputPortView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="### obsolete\ServiceParameterCollectionCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\ServiceParameterCollectionCollectionView.Designer.cs">
+      <DependentUpon>ServiceParameterCollectionCollectionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="### obsolete\ServiceParameterCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\ServiceParameterCollectionView.Designer.cs">
+      <DependentUpon>ServiceParameterCollectionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="### obsolete\ServiceParameterView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\ServiceParameterView.Designer.cs">
+      <DependentUpon>ServiceParameterView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="### obsolete\ValuePortView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="### obsolete\ValuePortView.Designer.cs">
+      <DependentUpon>ValuePortView.cs</DependentUpon>
+    </Compile>
     <Compile Include="ClientNodeView.cs">
       <SubType>UserControl</SubType>
@@ -103,4 +151,28 @@
       <DependentUpon>AlgorithmServiceNodeView.cs</DependentUpon>
     </Compile>
+    <Compile Include="GenericPortView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="GenericPortView.Designer.cs">
+      <DependentUpon>GenericPortView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="MessageValueCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="MessageValueCollectionView.Designer.cs">
+      <DependentUpon>MessageValueCollectionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="MessageView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="MessageView.Designer.cs">
+      <DependentUpon>MessageView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="ParameterizedPortView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ParameterizedPortView.Designer.cs">
+      <DependentUpon>ParameterizedPortView.cs</DependentUpon>
+    </Compile>
     <Compile Include="EntitySelector.cs">
       <SubType>UserControl</SubType>
@@ -121,33 +193,15 @@
       <DependentUpon>EntityView.cs</DependentUpon>
     </Compile>
-    <Compile Include="InputOutputPortView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="InputOutputPortView.Designer.cs">
-      <DependentUpon>InputOutputPortView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ClientServicePortView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ClientServicePortView.Designer.cs">
-      <DependentUpon>ClientServicePortView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ClientPortView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ClientPortView.Designer.cs">
-      <DependentUpon>ClientPortView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ServiceParameterCollectionCollectionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ServiceParameterCollectionCollectionView.Designer.cs">
-      <DependentUpon>ServiceParameterCollectionCollectionView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ServiceParameterCollectionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ServiceParameterCollectionView.Designer.cs">
-      <DependentUpon>ServiceParameterCollectionView.cs</DependentUpon>
+    <Compile Include="MessageValueView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="MessageValueView.Designer.cs">
+      <DependentUpon>MessageValueView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="PortParameterCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="PortParameterCollectionView.Designer.cs">
+      <DependentUpon>PortParameterCollectionView.cs</DependentUpon>
     </Compile>
     <Compile Include="PortView.cs">
@@ -157,9 +211,9 @@
       <DependentUpon>PortView.cs</DependentUpon>
     </Compile>
-    <Compile Include="ServiceParameterView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ServiceParameterView.Designer.cs">
-      <DependentUpon>ServiceParameterView.cs</DependentUpon>
+    <Compile Include="PortParameterView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="PortParameterView.Designer.cs">
+      <DependentUpon>PortParameterView.cs</DependentUpon>
     </Compile>
     <Compile Include="VariablesNodeView.cs">
@@ -174,16 +228,4 @@
     <Compile Include="AlgorithmNodeView.Designer.cs">
       <DependentUpon>AlgorithmNodeView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="InputPortView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="InputPortView.Designer.cs">
-      <DependentUpon>InputPortView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ValuePortView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ValuePortView.Designer.cs">
-      <DependentUpon>ValuePortView.cs</DependentUpon>
     </Compile>
     <Compile Include="NodeView.cs">